package com.aitrainer.api.controller

import org.springframework.beans.factory.annotation.Value
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

@RestController
@RequestMapping
class ApplicationProperties {

    @Value("\${application.version}")
    private lateinit var version: String

    @Value("\${spring.datasource.url}")
    private lateinit var datasourceUrl: String

    @Value("\${spring.datasource.username}")
    private lateinit var datasourceUsername: String

    @Value("\${spring.datasource.password}")
    private lateinit var datasourcePassword: String



    @GetMapping("/version")
    fun getVersion(): String {
        return this.version
    }

    @GetMapping("/datasourceUrl")
    fun getDatasourceUrl(): String {
        return this.datasourceUrl
    }

    @GetMapping("/datasourceUsername")
    fun getDatasourceUsername(): String {
        return this.datasourceUsername
    }

    @GetMapping("/datasourcePassword")
    fun getDatasourcePassword(): String {
        return this.datasourcePassword
    }
}