package com.aitrainer.api.controller

import com.aitrainer.api.model.ExerciseDevice
import com.aitrainer.api.repository.ExerciseDeviceRepository
import org.slf4j.LoggerFactory
import org.springframework.http.ResponseEntity
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

@RestController
@RequestMapping("/api")
class ExerciseDeviceController(private val exerciseDeviceRepository: ExerciseDeviceRepository) {
    private val logger = LoggerFactory.getLogger(javaClass)

    @GetMapping("/exercise_device")
    fun getDevicesWithTranslation(): ResponseEntity<List<ExerciseDevice>> {
        val list = exerciseDeviceRepository.getExerciseDevices()

        logger.info(" -- Get All ExerciseDevices $list")
        return if (list.isEmpty()) ResponseEntity.notFound().build() else
            ResponseEntity.ok().body(list)
    }
}