package com.aitrainer.api.controller

import com.aitrainer.api.model.ExerciseTreeParents
import com.aitrainer.api.repository.ExerciseTreeParentsRepository
import org.slf4j.LoggerFactory
import org.springframework.http.ResponseEntity
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.PathVariable
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

@RestController
@RequestMapping("/api")
class ExerciseTreeParentsController (private val exerciseTreeParentsRepository: ExerciseTreeParentsRepository) {
    private val logger = LoggerFactory.getLogger(javaClass)

    @GetMapping("/exercise_tree_parents/{id}")
    fun getAllByChildId(@PathVariable(value = "id") exerciseTreeParentsChildId: Long): ResponseEntity<List<ExerciseTreeParents>> {
        val list: List<ExerciseTreeParents> = exerciseTreeParentsRepository.findByExerciseTreeChildId(exerciseTreeParentsChildId).orEmpty()

        logger.info(" -- Get All Exercise Tree Parents by $exerciseTreeParentsChildId:  $list")
        return if (list.isEmpty()) ResponseEntity.notFound().build() else
            ResponseEntity.ok().body(list)
    }

    @GetMapping("/exercise_tree_parents")
    fun getAll(): ResponseEntity<List<ExerciseTreeParents>> {
        val list: List<ExerciseTreeParents> = exerciseTreeParentsRepository.findAll().orEmpty()

        logger.info(" -- Get All Exercise Tree Parents by $list")
        return if (list.isEmpty()) ResponseEntity.notFound().build() else
            ResponseEntity.ok().body(list)
    }
}