package com.aitrainer.api.model

import org.hibernate.annotations.Fetch
import org.hibernate.annotations.FetchMode
import javax.persistence.*
import javax.validation.constraints.NotBlank

@Entity
data class ExerciseDevice (
        @Id
        @GeneratedValue(strategy = GenerationType.IDENTITY)
        val exerciseDeviceId: Long = 0,

        @get: NotBlank var name: String = "",
        @get: NotBlank var description: String = "",
        @get: NotBlank var imageUrl: String = "",
        @get: NotBlank var sort: Int = 0,
        @get: NotBlank var place: Int = 0
){
        @OneToMany(cascade = [(CascadeType.ALL)], fetch = FetchType.EAGER, mappedBy = "exerciseDevice")
        @Fetch(value = FetchMode.SUBSELECT)
        val translations: List<ExerciseDeviceTranslation> = mutableListOf<ExerciseDeviceTranslation>().toList()

        @OneToMany(cascade = [(CascadeType.ALL)], fetch = FetchType.EAGER, mappedBy = "exerciseDevice")
        @Fetch(value = FetchMode.SUBSELECT)
        val alternatives: List<ExerciseDeviceAlternative> = mutableListOf<ExerciseDeviceAlternative>().toList()
}
