package com.aitrainer.api.test


import com.aitrainer.api.controller.ExerciseTreeController
import com.aitrainer.api.controller.ExerciseTreeParentsController
import com.aitrainer.api.model.ExerciseTree
import com.aitrainer.api.model.ExerciseTreeParents
import com.aitrainer.api.repository.ExerciseTreeParentsRepository
import com.aitrainer.api.repository.ExerciseTreeRepository
import org.junit.jupiter.api.Test
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.boot.test.context.SpringBootTest
import org.springframework.http.ResponseEntity
import kotlin.test.assertEquals
import kotlin.test.assertTrue

@SpringBootTest
class ExerciseTreeParentsTest {

    @Autowired
    private lateinit var exerciseTreeParentsRepository: ExerciseTreeParentsRepository
    
    @Test
    fun testTreeParents() {
        val exerciseTreeParentsController = ExerciseTreeParentsController(exerciseTreeParentsRepository)
        val responseEntity: ResponseEntity<List<ExerciseTreeParents>> = exerciseTreeParentsController.getAllByChildId(20)

        assertTrue(responseEntity.body!!.isNotEmpty())
        val exerciseTreeParentList = responseEntity.body!!
        assertEquals(exerciseTreeParentList.size, 2)
        assertEquals(exerciseTreeParentList[0].exerciseTreeParentId, 9)
        assertEquals(exerciseTreeParentList[1].exerciseTreeParentId, 10)
    }

    @Test
    fun testAllTreeParents() {
        val exerciseTreeParentsController = ExerciseTreeParentsController(exerciseTreeParentsRepository)
        val responseEntity: ResponseEntity<List<ExerciseTreeParents>> = exerciseTreeParentsController.getAll()

        assertTrue(responseEntity.body!!.isNotEmpty())
        val exerciseTreeParentList = responseEntity.body!!
        assertEquals(exerciseTreeParentList.size, 27)
        assertEquals(exerciseTreeParentList[4].exerciseTreeParentId, 3)
        assertEquals(exerciseTreeParentList[4].exerciseTreeChildId, 7)

    }
}